DBD = {}

SLASH_DBD1 = "/dbd"
SlashCmdList["DBD"] = function(msg)
	if (msg == "disable") then
		DBD.enabled = false
	elseif (msg == "enable") then
		DBD.enabled = true
	elseif (msg == "reward") then
		DBD.reward = not DBD.reward
		print("DBD reward is "..tostring(DBD.reward))
	else
		if DBD.enabled then
			print("DBD is enabled")
		else
			print("DBD is disabled")
		end
	end
end

--[[ Special thanks to :
-- Da_bernie @ wowinterface for German client fix :)
-- bsmorgan @ wowinterface for all that below xD
--]]

local AiLvl, WiLvl, pickA, pickW;
local DBDF=CreateFrame("Frame");
DBDF:RegisterEvent("ADDON_LOADED");
DBDF:RegisterEvent("GOSSIP_SHOW");
DBDF:RegisterEvent("QUEST_DETAIL");
DBDF:RegisterEvent("QUEST_PROGRESS");
DBDF:RegisterEvent("QUEST_COMPLETE");

DBDF:SetScript("OnEvent",function(self,event,msg,...)
	if (event == "ADDON_LOADED" and msg == "DBD") then
		if DBD.enabled == nil then
			DBD.enabled = true
		end
		if DBD.reward == nil then
			DBD.reward = false
		end
	end
	local guid = UnitGUID("target")
	local scraps = GetItemCount(113681,true)
	if DBD.enabled and guid and scraps >= 25 then
		local gtype, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid);
		if gtype == "Creature" and (npc_id == "77377" or npc_id == "79815") then
			if (event == "GOSSIP_SHOW") then
				if GetGossipAvailableQuests() then
					local _,QuestsInLog = GetNumQuestLogEntries()
					if QuestsInLog <= 24 then
						SelectGossipAvailableQuest(1)
					else
						print("DBD: Quest log is full")
					end
				end
				SelectGossipActiveQuest(1)
				CompleteQuest()
				return
			end -- GOSSIP_SHOW
			local quest_id = GetQuestID()
			if (quest_id == 38175 or quest_id == 38188) then -- Insurance against future changes
				if (event == "QUEST_DETAIL") then
					AcceptQuest()
				elseif (event == "QUEST_PROGRESS") then
					CompleteQuest()
					if DataStore then
						local character = DataStore:GetCharacter()
						AiLvl = DataStore:GetAvgArmoriLevel(character) or 0
						WiLvl = DataStore:GetAvgWeaponiLevel(character) or 0
						pickA = " "
						pickW = " "
						if ((AiLvl + WiLvl) ~= 0) then
							if (AiLvl < WiLvl) then
								pickA = "* "
							elseif (AiLvl > WiLvl) then
								pickW = "* "
							end
							print(format("Armor%s= %.1f, Weapon%s= %.1f",pickA,AiLvl,pickW,WiLvl))
						end
					end -- Checking if DataStore is enabled
				elseif (event == "QUEST_COMPLETE" and DBD.reward) then
					if DataStore then
						if (pickA == "* ") then
							GetQuestReward(1)
						elseif (pickW == "* ") then
							GetQuestReward(2)
						end
					end -- Checking if DataStore is enabled
				end -- QUEST_COMPLETE
			end -- quest_id
		end -- npc_id
	end
end)
